﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;

namespace HeuristicLab.BioBoost.Views {
  public static class EnumerableExtentions {
    /// <summary>
    /// Returns the index of the first element in source matched by predicate.
    /// </summary>
    public static int IndexOfFirst<T>(this IEnumerable<T> source, Func<T, bool> predicate) {
      int i = 0;
      foreach (T item in source) {
        if (predicate(item)) {
          return i;
        }
        i++;
      }
      return -1;
    }
  }
}
