﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using HeuristicLab.BioBoost.Utils;
using HeuristicLab.Common;
using HeuristicLab.Encodings.RealVectorEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.BioBoost.Operators.Mutation {

  [StorableClass]
  public class PlantSupplierRandomizer : PlantBasedUtilizationModifier {

    #region Construction & Cloning
    [StorableConstructor]
    public PlantSupplierRandomizer(bool isDeserializing) {}
    public PlantSupplierRandomizer(PlantSupplierRandomizer orig, Cloner cloner) : base(orig, cloner) {}
    public PlantSupplierRandomizer() {}
    public override IDeepCloneable Clone(Cloner cloner) {
      return new PlantSupplierRandomizer(this, cloner);
    }
    #endregion

    public override void Redistribute(RealVector utilizations, List<int> supplierIndices) {
      foreach (var i in supplierIndices) {
        utilizations[i] = EnforceBounds(utilizations[i] * Util.Sqr(Random.NextDouble() + 0.5), i);
      }
    }


  }
}
